/*Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-EPD0154-1Y
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Works with Arduino DUE,Arduino mega2560,Arduino UNO Board
****************************************************/
#include "ER-EPD0154-1.h"
#include "GUI_Paint.h"
#include "EPD_SDCard.h"
#include "ImageData.h"
#include <Wire.h>
#include <SPI.h>
#include <SD.h>
 
void setup()
{
    GUIPAINT paint;
    EPD1IN54 epd;
    EPD_SDCARD SD;

    if(epd.EPD_Init() != 0) {
        Serial.print("e-Paper init failed");
        return;
    }
    epd.EPD_Clear();
    Serial.print("1.54inch e-Paper c demo\n");
    
#if 1   
    /*show sd card pic*/
    //1.Initialize the SD card
    SD.SDCard_Init();

    //2.Create a new image cache named IMAGE_BW and fill it with white
    //Draw black image
    Serial.print("IMAGE_BW\n");
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    //3.Read BMP images into RAM
    SD.SDCard_ReadBMP("154-1yb1.bmp", 0, 0);

    //Draw red image
    Serial.print("IMAGE_BWR\n");
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    SD.SDCard_ReadBMP("154-1yy1.bmp", 0, 0);
    //4.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);   
    
    //2.Create a new image cache named IMAGE_BW and fill it with white
    //Draw black image
    Serial.print("IMAGE_BW\n");
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    //3.Read BMP images into RAM
    SD.SDCard_ReadBMP("154-1yb2.bmp", 0, 0);

    //Draw red image
    Serial.print("IMAGE_BWR\n");
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);
    SD.SDCard_ReadBMP("154-1yy2.bmp", 0, 0);
    //4.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);      
 #endif  
 //#elif 0
 #if 0
    /*show image for array*/
    //1.Draw black image
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_DrawBitMap(IMAGE_BLACK);

    //2.Draw red image
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_DrawBitMap(IMAGE_RED);

    //3.Refresh the image in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
#endif

#if 0
    /*Horizontal screen*/
    //1.Draw black image
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_90, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    paint.Paint_DrawPoint(10, 10, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(10, 25, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);   
    paint.Paint_DrawLine(45, 70, 45, 110, BLACK, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(25, 90, 65, 90, BLACK, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawRectangle(20, 10, 70, 60, BLACK, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawCircle(115, 90, 20, BLACK, DRAW_FILL_FULL, DOT_PIXEL_1X1);
    paint.Paint_DrawNum(45, 135, 123456789, &Font12, WHITE, BLACK);

    //2.Draw red image
    paint.Paint_NewImage(IMAGE_BWR, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_90, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    paint.Paint_DrawPoint(10, 40, BLACK, DOT_PIXEL_3X3, DOT_STYLE_DFT);
    paint.Paint_DrawLine(20, 10, 70, 60, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(70, 10, 20, 60, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);        
    paint.Paint_DrawRectangle(90, 10, 140, 60, BLACK, DRAW_FILL_FULL, DOT_PIXEL_1X1);        
    paint.Paint_DrawCircle(45, 90, 20, BLACK, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);    
    paint.Paint_DrawString_EN(0, 115, "EastRising", &Font16, BLACK, WHITE);    
    
    //3.Refresh the image in RAM to e-Paper
    epd.EPD_Display();  

#endif

    Dev->Dev_Delay_ms(15000);
    epd.EPD_Clear();
    epd.EPD_SendCommand(DISPLAY_REFRESH);
    epd.EPD_WaitUntilIdle();

    epd.EPD_Sleep();
    
}

void loop()
{

}
